/*
 *********
 *
 *  by  E R R O R  Message (ErrorMsg@gawab.com)
 *  a templete for allegro
 *  you may change few things in this file like 320x200 res
 *********
 *
 * for static link here is the comileing and linking options (need not alleg40.dll)
 * CompilerOptions=-DALLEGRO_STATICLINK
 * Linker=-lalleg_s -lgdi32 -ldxguid -lole32 -ldinput -lddraw -lwinmm -ldsound
 *
 *******
 * for dynamic linking (needs alleg40.dll)
 * CompilerOptions=
 * Linker= -l alleg
 *
 */
#include <stdio.h>  // for sprintf
#include <stdlib.h> // for exit & rand
#include <time.h>   // to send time to srand

#include "allegro.h"
// normally the data files are not needed here if they are uncomment next line
//#include "mydata1.h" // this file generated by Graber that you make the .dat file with

// you can put some global var here (extern becuase they are defined in the other .cpp file)
// if you need some here just uncomment it
/*
extern DATAFILE *data1;
extern PALETTE pal1,pal2;
*/
// more variables defined on the other file
// if you need some here just uncomment it
/*
extern SAMPLE *snd1,*snd2;
extern MIDI   *Midi1,*Midi2;
extern DATAFILE *data1;
extern BITMAP *pic1,*pic2;
extern BITMAP *enmy[3],*man[4],*jul[6]; // you can put array of pic like this
*/

BITMAP *buf;    // this is the buffer to draw on
int SOUND_OK=0; // this will set to 1 if sound is OK
int GameOver=0; // this will set to 1 if the game is over or t exit

      // this 3 lines to have same speed game in slow and fast PCs
      volatile int speed_counter = 0; // how many frame(s) to move on(skip)
      void my_timer()  { speed_counter++;}
      END_OF_FUNCTION(my_timer); // some allegro magic

// here i'll put the prototypes for my functions
void init_graph();
void install_timers();
void init();

// here i'll put the prototypes for my functions that are in other .cpp file
extern void loading();
extern void NoSkipUpDate();
extern void Update();
extern void update_display();

int main(int argc,char *argv[]) 
{
    //
    init(); // graph, keyboard, timer , sound
    buf=create_bitmap(320, 200); // create buffer to draw on it then copy to screen
    loading(); // load dat file
    set_palette(pal1);
    // game start here
    while (!GameOver)
    {
        while (speed_counter==0); // wait until next frame time come
        NoSkipUpDate();
                // what needs to be done seq ie to show counter 5 to 1
                // and if the computer is slow it may skip to show 3
                // so if you want to view them all put them in NoSkipUpDate();
                // normally you do not need such thing
        while (speed_counter > 0) {UpDate(); --speed_counter;}
        speed_counter=0;
        update_display();
    }
    // Exit program.
    // destroy_bitmap(a bitmap); // you can manual remove bitmap to save memory
    allegro_exit(); // uninstall timers,sound ... etc
    return 0;     
} END_OF_MAIN(); // Some Allegro magic to deal with WinMain().
void init_graph()
{
    set_color_depth(8); // 256 color
    // give any 320x200 screen ( you can replace 320x200 with any resulution)
    // now try full secreen with acceleration
    if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN , 320, 200, 0, 0) != 0)
        {
        // if fail try safe (may be windowed mode)
        if (set_gfx_mode(GFX_SAFE , 320, 200, 0, 0) != 0)
           {
           // if fail return to text mode and exit
           set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
           // the format of allegro_message is like printf
           allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
           exit(1);
           }
        }
}
void install_timers()
{
    //Install timer ...
    // speed_counter is var dente how may frame to skip in the computer is slow
    // my_timer is a func that increase that var by 1 each frame
    LOCK_VARIABLE(speed_counter); // allegro magic to prevent system halt
    LOCK_FUNCTION(my_timer); // allegro magic to prevent system halt
    //use MSEC_TO_TIMER(msec) or BPS_TO_TIMER(bps)
    // msec=x mean to call the func each x milly sec
    // bps =x mean to call the func x times in a sec
    install_int_ex(my_timer, BPS_TO_TIMER(24)); // call my_timer() 24 times per sec
}
void init()
{
    allegro_init();
    install_keyboard(); // you can see if a ESC is pressed by key[KEY_ESC] 
    install_timers();
    // install wav and midi sound
    if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) != 0)
    {
      allegro_message("Error initialising sound system\n%s\n", allegro_error);
      install_sound (DIGI_NONE, MIDI_NONE, NULL);
      SOUND_OK=0;
    }
    else SOUND_OK=1;
    //     when you change the volume call like next line
    // if (SOUND_OK) set_volume(digi_volume, midi_volume);
    //     when you want to play midi call like next line
    // if (SOUND_OK) play_midi(MidiPrt,true); // true mean repeat forever
    //     when you want to stop midi (end the forever loop)
    // if (SOUND_OK) stop_midi();
    //     when you want to play wav or voc call like this
    // if (SOUND_OK) play_sample(WavPtr, 255,127 , WavPtr->freq, false); // false mean do not repeat
    init_graph(); // my func to select graphic mode

}
