/*
 * stopwatch.c: A stopwatch with Gtk+2
 *
 * by Moayyad Al-Sadi<ErrorMsg@gawab.com>
 * released under the terms of the GNU General Public License
 * visit www.fsf.org or www.gnu.org
 */
#include <glib.h>
#include <gtk/gtk.h>
/* Public variables */
        GTimer *timer1;
        GtkWidget *win, *vbox1,*hbox1;
        GtkWidget *label1;
        GtkWidget *timer, *stopbtn,*startbtn,*resetbtn;
        gchar str[100]; double oldt=-1.0,newt=0.0;
/* idle function to update timer */
gint update_timer(gpointer ptr) {
        g_ascii_formatd(str,99,"%29.3f",newt=g_timer_elapsed(timer1,NULL));
        if (oldt!=newt)
                gtk_entry_set_text(GTK_ENTRY (timer),str);
        oldt=newt;
}
/* handlers for click the 3 buttons */
void start_event() {
        g_timer_start(timer1);
        update_timer(NULL);
}
void stop_event() {
        g_timer_stop(timer1);
        update_timer(NULL);
}
void reset_event() {
        g_timer_reset(timer1);
        g_timer_stop(timer1);
        update_timer(NULL);
}

int main(int argc, char *argv[]) {
        /* create the timer and put it on 0.0 */
        timer1=g_timer_new();
        g_timer_reset(timer1);
        g_timer_stop(timer1);

        gtk_init(&argc, &argv);
        /* Build the gui */
        win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
        vbox1 = gtk_vbox_new(FALSE,3); /* homo,spacing */
        label1=gtk_label_new("Moayyad al-Sadi Stopwatch");
        timer=gtk_entry_new();
        hbox1 = gtk_hbox_new(TRUE,3);
        startbtn=gtk_button_new_with_label("start");
        stopbtn=gtk_button_new_with_label("stop");
        resetbtn=gtk_button_new_with_label("reset");
        /* add each widget to it parent */
        gtk_container_add(GTK_CONTAINER (win),vbox1);
        gtk_box_pack_start(GTK_BOX(vbox1),label1,	FALSE, FALSE,0); /* resize=shrink=false */
        gtk_box_pack_start(GTK_BOX(vbox1),timer,        FALSE, FALSE,0);
        gtk_box_pack_start(GTK_BOX(vbox1),hbox1,        TRUE, FALSE,0);
        gtk_box_pack_start(GTK_BOX(hbox1),startbtn,     TRUE, FALSE,0);
        gtk_box_pack_start(GTK_BOX(hbox1),stopbtn,      TRUE, FALSE,0);
        gtk_box_pack_start(GTK_BOX(hbox1),resetbtn,     TRUE, FALSE,0);
        /* set some properties */
        /* gtk_window_set_default_size(GTK_WINDOW(win), 300, 300); */
        gtk_window_set_title(GTK_WINDOW(win),"Moayyad Stopwatch");
        gtk_editable_set_editable(GTK_EDITABLE(timer),FALSE);
        /* connect events */
        g_signal_connect(G_OBJECT(win),"destroy",gtk_main_quit,NULL);
        g_signal_connect(G_OBJECT(startbtn),"clicked", start_event,NULL);
        g_signal_connect(G_OBJECT(stopbtn),"clicked", stop_event,NULL);
        g_signal_connect(G_OBJECT(resetbtn),"clicked", reset_event,NULL);
        gtk_idle_add(update_timer,NULL);
        /* show all and wait to exit */
        gtk_widget_show_all(win);
        gtk_main();
        return 0;
}
