#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SERVER  "/tmp/serversocket"
#define CLIENT  "/tmp/mysocket"
#define MAXMSG  512
  /* This function is defiend in our 'socket-common.c' */
  extern int make_named_socket (const char *name);

int main (int argc,char *argv[]) {

  int sock;
  struct sockaddr_un name;
  size_t size;
  int nbytes;
  /* Process arguments and show usage */
  if (argc!=2) {
        printf("mysock-lo-dgram-client: sample socket testing client
syntax: mysock-lo-dgram-client STRGING
where STRING is the string to send to server.
example:
        mysock-lo-dgram-client 'Hello every body'
");
        exit(0);
  }
  /* Make the socket. */
  sock = make_named_socket (CLIENT);
  /* Initialize the server socket address. */
  name.sun_family = AF_LOCAL;
  strcpy (name.sun_path, SERVER);
  size=SUN_LEN (&name); /* it was strlen(name.sun_path) + sizeof(name.sun_family) */
  /* Send the datagram. */
  nbytes = sendto (sock, argv[1], strlen (argv[1]) + 1, 0, (struct sockaddr *)& name, size);
  if (nbytes < 0) {
      perror ("sendto (client)"); exit (-1);
  }
  /* Clean up. */
  remove (CLIENT);
  close (sock);
  return 0;
}
