/* hello.c - dummy kernel module from Modules-HOWTO
 *
 * "Hello, world" - the loadable kernel module version.
 *
 * Compile this with
 *          gcc -c hello.c -Wall
 * put it in lib/modules and do modprobe hello
 *
 */
/* Declare what kind of code we want from the header files */
#define __KERNEL__         /* We're part of the kernel */
#define MODULE             /* Not a permanent part, though. */
/* Standard headers for LKMs */
#include <linux/modversions.h>
#include <linux/module.h>
#define _LOOSE_KERNEL_NAMES
    /* With some combinations of Linux and gcc, tty.h will not compile if
       you don't define _LOOSE_KERNEL_NAMES.
    */
#include <linux/tty.h>      /* console_print() interface */
/* Initialize the LKM */
int init_module()
{
  console_print("Hello, world - this is the kernel speaking\n");
  /* or simply use printk("Hello") */
  return 0; /* 0 success ; else failed */
}
/* Cleanup - undo whatever init_module did */
void cleanup_module()
{
  console_print("Short is the life of an LKM\n");
}
