// mylist.cpp: MyList class methods serves as lib for our project
/*
 * A project to show how to make a multi file project.
 * By Moayyad Al-Sadi
 * (c) Copyleft 2004, under terms of LGPL
 */
#define _MY_LIST_CPP_
#include<iostream.h> // for NULL!
#include "mylist.h"

const char * MyListVersion="0.1.9a";

MyList::MyList() {
	// set every thing to ZERO
	n=0;
	head=tail=current=NULL;
}
MyList::~MyList() {
	// free all allocated memory by going to last one then prev ...
	ListNode *tmp=tail,*prev;
	while (tmp) {
		prev=tmp->prev;
		delete tmp;
		tmp=prev;
	}
	head=tail=NULL;
}
int MyList::Count() {
	return n;
}
ListNode* MyList::Add(int val) {
	ListNode *tmp=new ListNode; // allocate a new node
	if (!tmp) return NULL; // make sure there is enough mem
	// fix it's prev,next,value members
	tmp->prev=tail; tmp->next=NULL;
	tmp->value=val;
	// make it's prev's next point to it
	if (tail) tail->next=tmp;
	// if there is no head so this is 1st element
	if (!head) head=tmp;
	// set the new as current and last element
	current=tail=tmp;
	++n;
	return tmp;
}
void MyList::ForEach(void (*myfunc)(int &)) {
	// Goto 1st element then next then next ...
	ListNode *tmp=head;
	while (tmp) {
		myfunc(tmp->value);
		tmp=tmp->next;
	}
	
}
int* MyList::Head() {
	return ((head)? &(head->value) :NULL);
}
int* MyList::Tail() {
	return ((tail)? &(tail->value) :NULL);
}
int* MyList::Next() {
	if (!current || !current->next) return NULL;
	current=current->next;
	return &(current->value);
}
int* MyList::Prev() {
	if (!current || !current->prev) return NULL;
	current=current->prev;
	return &(current->value);
}
