/* sdl-tut.c: SDL tutorial by Moayyad Al-Sadi <errormsg@gawab.com> */
#include "SDL.h"
#include <stdio.h>
#include <math.h>
/* this function draw some scratch to sraface */
void scratch(SDL_Surface *surface) {
        int x=100,y=100;
        char *file_name="mybmp.bmp";
        SDL_Surface image;
        Uint8 *ptr;
        /* bpp=BitPerPixel , Bpp=BytePerPexil*/
        int bpp=surface->format->BitsPerPixel,Bpp=ceil(bpp/8.0);
        Uint32 c1=SDL_MapRGB(bpp,64,64,128);
        Uint32 c2=SDL_MapRGB(bpp,128,64,64);
        SDL_Rect r;
        /* load BMP file */
        image = SDL_LoadBMP(file_name);
        if (image == NULL) {
                fprintf(stderr, "Couldn't load %s: %s\n",
                        file_name, SDL_GetError());
                return;
        }
        SDL_BlitSurface(image, NULL, surface, NULL);
        SDL_UpdateRect(surface, 0, 0, 0, 0);
        SDL_FreeSurface(image);
        /* draw rectangle */
        r.x=10; r.y=10; r.w=200; r.h=200;
        SDL_FillRect(surface,&r,c1);
        SDL_UpdateRect(surface, 0, 0, 0, 0);
        /* direct access draw line */
        SDL_LockSurface(surface);
        ptr = (Uint8 *)surface->pixels + y * surface->pitch + x * Bpp;
        switch(bpp) {
        case 1:
                for (;x<300;++x) *p++ = c2;
                break;
        case 2:
                for (;x<300;++x) *(Uint16 *)p++ = c2;
                break;
        case 4:
                for (;x<300;++x) *(Uint32 *)p++ = c2;
                break;
        }
        SDL_UnlockSurface(surface);

}
int main() {
        SDL_Surface *screen;
        SDL_Event event;
        printf("Initializing SDL.\n");
        if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER)==-1)) {
                printf("Could not initialize SDL: %s.\n", SDL_GetError());
                exit(-1);
        }
        printf("SDL initialized.\n");
        screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE);
        if ( screen == NULL ) {
                fprintf(stderr,
                        "Could not set 640x480x16 video mode: %s\n",
                        SDL_GetError());
                exit(1);
        }
        /* draw scratch on screen */
        scratch(screen);
        /* wait to exit */
        while(1) {
        while( SDL_PollEvent( &event ) ) {
                switch( event.type ) {
                case SDL_KEYDOWN:
                        if (event.key.keysym.sym==SDLK_ESCAPE) {
                                SDL_Quit( ); exit(0);
                        }
                        break;
                case SDL_QUIT:
                        SDL_Quit( ); exit(0);
                        break;
                }
        }
        /* DO SOME THINGS HERE like move the scratch */
        /* ... do it your self :-( */
        }

        /* never come here */
        return 0;
}
