/* sdl-gl.c: OpenGL and SDL tutorial by Moayyad Al-Sadi <errormsg@gawab.com> */
#include "SDL.h"
#include <stdio.h>
#include <math.h>

float vertices[][3]={
        {-20,-20, 20},{20,-20, 20},{20,20, 20},{-20,20, 20},
        {-20,-20,-20},{20,-20,-20},{20,20,-20},{-20,20,-20}
}
// the indices to form the cube
unsigned int indeces[24]={ /* 24 = 4 points in 6 sides */
        0,1,2,3, /* the 1st side by connect 0-1-2-3-0 */
        1,5,6,2,
        4,5,6,7,
        4,0,3,7,
        3,2,6,7,
        0,1,5,4
}
float colors[6][3]={
        {1.0,0.0,0.0},{0.0,1.0,0.0},
        {0.0,0.0,1.0},{1.0,1.0,0.0},
        {0.0,1.0,1.0},{1.0,0.0,1.0}
}

/* this function draw some 3D sample to sraface */
void draw_gl(SDL_Surface *surface) {
    /* Draw things here ,the GL-way ... */
    int i,j,k=0;
    glViewport( 0, 0, 640, 480 );
    glMatrixMode(GL_PROJECTIION);
    glLoadIdentity();
    glOrtho(-25,25,-25,25,-25,25);
    glMatrixMode(GL_MODLEVIEW);

    glClearColor(1.0,1.0,1.0,1.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glBegin(GL_QUADS)
    for (int i=0;i<6;++i) {
       glColor3fv(colors[i]);
       for (int j=0;j<4;++j,++k)
       glVertex3fv(vertecs[indeces[k]]);
    }
    glEnd();
    glFlush();
    /* update screen */
    SDL_GL_SwapBuffers();
}
int main() {
        SDL_Surface *screen;
        SDL_Event event;
        printf("Initializing SDL.\n");
        if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_TIMER)==-1)) {
                printf("Could not initialize SDL: %s.\n", SDL_GetError());
                exit(-1);
        }
        printf("SDL initialized.\n");
	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 6 );
        SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
        SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
        SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
        screen = SDL_SetVideoMode(640, 480, 16, SDL_OPENGL | SDL_FULLSCREEN);

        if ( screen == NULL ) {
                fprintf(stderr,
                        "Could not set 640x480x16 video mode: %s\n",
                        SDL_GetError());
                exit(1);
        }
        /* draw 3D scratch on screen */
        draw_gl(screen);
        /* wait to exit */
        while(1) {
        while( SDL_PollEvent( &event ) ) {
                switch( event.type ) {
                case SDL_KEYDOWN:
                        if (event.key.keysym.sym==SDLK_ESCAPE) {
                                SDL_Quit( ); exit(0);
                        }
                        break;
                case SDL_QUIT:
                        SDL_Quit( ); exit(0);
                        break;
                }
        }
        }

        /* never come here */
        return 0;
}
